!  This program sums LENGTH numbers
!  Figure 4-14 of Murdocca/Heuring text
!  Register usage:  %r1 - Length of array a
!                   %r2 - Starting address of array a
!                   %r3 - The partial sum
!                   %r4 - Pointer into array a
!                   %r5 - Holds an element of a

          .begin
          .org      2048            ! (Default origin)
a_start   .equ      3000
          ld        [length], %r1   ! r1 <- length of a
          ld        [address], %r2  ! r2 <- address of a
          andcc     %r3, %r0, %r3   ! r3 <- 0
loop:     andcc     %r1, %r1, %r0   ! Test # remaining elements
          be        done            ! Finished when length = 0
          addcc     %r1, -4, %r1    ! Decrement array length
          addcc     %r1, %r2, %r4   ! Address of next element
          ld        %r4, %r5        ! r5 <- Memory[ r4 ]
          addcc     %r3, %r5, %r3   ! Sum new element into r3
          ba        loop

done:     jmpl      %r15 + 4, %r0   ! Return to caller

length:             20              ! 5 numbers (20 bytes) in a
address:            a_start
          .org      a_start
a:                  25
                   -10
                    33
                   -5
                    7
          .end
